'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = aggregateBundles;

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

function aggregateBundles() {
  var state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var newBundle = arguments[1];

  state = Object.assign({}, state); // copy

  for (var key in newBundle) {
    var obj = newBundle[key];
    if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object' && !Array.isArray(obj)) {
      if (_typeof(state[key]) !== 'object') {
        state[key] = {};
      }

      if (_typeof(obj.insert) === 'object') {
        for (var str in obj.insert) {
          state[key][str] = obj.insert[str];
        }
      }

      if (Array.isArray(obj.remove) && obj.remove.length > 0) {
        for (var str in state) {
          if (obj.remove.indexOf(state[str]) > -1) {
            delete state[str];
          }
        }
      }
    } else {
      state[key] = newBundle[key];
    }
  }

  return state;
}