"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createObservable;

var _rx = require("rx");

var _createDataStream = require("../decoding/createDataStream");

var _createDataStream2 = _interopRequireDefault(_createDataStream);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createObservable(socket) {
  var parser = (0, _createDataStream2.default)();
  return _rx.Observable.create(function (observer) {
    socket.pipe(parser);

    socket.on("error", function (err) {
      observer.onError(err);
    });

    socket.on("end", function () {
      observer.onCompleted();
    });

    parser.on("readable", function () {
      var payload = undefined;
      while (payload = parser.read()) {
        observer.onNext(payload);
      }
    });
  }).publish().refCount();
}