'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generateTreeFromDatabase;

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

function generateTreeFromDatabase(db) {
  var key = arguments.length <= 1 || arguments[1] === undefined ? 0 : arguments[1];

  var rec = function rec(sub) {
    if (Array.isArray(sub)) {
      return sub.map(function (x) {
        return rec(db[x]);
      });
    } else if ((typeof sub === 'undefined' ? 'undefined' : _typeof(sub)) === 'object') {
      var res = {};
      for (var _key in sub) {
        res[_key] = rec(db[sub[_key]]);
      }
      return res;
    }

    return sub;
  };

  return rec(db[key]);
}