'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createObserver;

var _rx = require('rx');

var _generateCommandBuffer = require('./generateCommandBuffer');

var _generateCommandBuffer2 = _interopRequireDefault(_generateCommandBuffer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function createObserver(socket) {
  return _rx.Observer.create(function (next) {
    if (next instanceof Buffer) {
      socket.write(next);
    } else if (Array.isArray(next)) {
      socket.write(_generateCommandBuffer2.default.apply(undefined, _toConsumableArray(next)));
    }
  }, function (err) {
    socket.on('error', err);
  }, function (done) {
    socket.destroy();
  });
}