'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generateCommandBuffer;

var _constants = require('../constants');

var nextCommandId = 1;
function encodePacket(type) {
  var args = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];

  var payload = JSON.stringify({
    type: type,
    args: args,
    id: nextCommandId++
  });

  var buffer = new Buffer(5 + payload.length);
  buffer.writeUInt32LE(payload.length, 0);
  buffer.writeUInt8(5, 4); // channel 5 == command request
  buffer.write(payload, 5);
  return buffer;
}

function generateCommandBuffer(type) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  if (args.length === 1 && Array.isArray(args[1])) {
    args = args[1];
  }

  if (!_constants.commands.hasOwnProperty(type)) {
    throw 'Unknown command type ' + type + '!';
  }

  return encodePacket(_constants.commands[type], args);
}